package org.beangle.struts2.convention.factory;

import java.util.List;

import org.beangle.commons.collection.ListUtil;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;

public class SpringBeanNameFinder extends DefaultBeanNameFinder implements ApplicationContextAware,
		BeanNameFinder {

	ApplicationContext appContext;

	public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
		appContext = applicationContext;
	}

	public ApplicationContext getApplicationContext() {
		return appContext;
	}

	public String[] getBeanNames(Class<?> type) {
		String[] names = appContext.getBeanNamesForType(type);
		if (null == names || names.length == 0) {
			return names;
		} else {
			List<String> lefts=ListUtil.newArrayList();
			if(names.length>1){
				for(String name:names){
					Class<?> beanType=appContext.getType(name);
					if(beanType.equals(type)){
						lefts.add(name);
					}
				}
				names=lefts.toArray(new String[lefts.size()]);
			}
			return names;
		}
	}
}
